import React, { useState } from "react";
import { StyleSheet, View } from "react-native";
import Line from "./Line";
const CodeEditor = () => {
    const [lines, setLines] = useState([""]);
    function onBackspace(lineNumber) {
        // TODO: this should be if the cursor is at index 0
        if (!lines[lineNumber]) {
            setLines(previousLines => {
                previousLines.splice(lineNumber, 1);
                return [...previousLines];
            });
        }
    }
    function onChange(text, lineNumber) {
        setLines(previousLines => {
            previousLines[lineNumber] = text;
            return [...previousLines];
        });
    }
    function onEnterPress(lineNumber) {
        setLines(previousLines => {
            previousLines.splice(lineNumber + 1, 0, "");
            return [...previousLines];
        });
    }
    return (React.createElement(React.Fragment, null,
        React.createElement(View, { style: styles.lineNumberBorder }),
        React.createElement(View, { style: styles.codeContainer }, lines.map((line, index) => (React.createElement(Line, { key: index, lineNumber: index, onBackspace: onBackspace, onChange: onChange, onEnterPress: onEnterPress, value: line }))))));
};
const styles = StyleSheet.create({
    codeContainer: {
        height: "100%",
        position: "absolute",
        width: "100%"
    },
    lineNumberBorder: {
        borderColor: "#000000",
        borderWidth: 0.5,
        height: "100%",
        left: 30,
        position: "absolute",
        width: 0
    }
});
export default CodeEditor;
